# generated from catkin/cmake/template/pkgConfig.cmake.in

# append elements to a list and remove existing duplicates from the list
# copied from catkin/cmake/list_append_deduplicate.cmake to keep pkgConfig
# self contained
macro(_list_append_deduplicate listname)
  if(NOT "${ARGN}" STREQUAL "")
    if(${listname})
      list(REMOVE_ITEM ${listname} ${ARGN})
    endif()
    list(APPEND ${listname} ${ARGN})
  endif()
endmacro()

# append elements to a list if they are not already in the list
# copied from catkin/cmake/list_append_unique.cmake to keep pkgConfig
# self contained
macro(_list_append_unique listname)
  foreach(_item ${ARGN})
    list(FIND ${listname} ${_item} _index)
    if(_index EQUAL -1)
      list(APPEND ${listname} ${_item})
    endif()
  endforeach()
endmacro()

# pack a list of libraries with optional build configuration keywords
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_pack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  set(_argn ${ARGN})
  list(LENGTH _argn _count)
  set(_index 0)
  while(${_index} LESS ${_count})
    list(GET _argn ${_index} lib)
    if("${lib}" MATCHES "^(debug|optimized|general)$")
      math(EXPR _index "${_index} + 1")
      if(${_index} EQUAL ${_count})
        message(FATAL_ERROR "_pack_libraries_with_build_configuration() the list of libraries '${ARGN}' ends with '${lib}' which is a build configuration keyword and must be followed by a library")
      endif()
      list(GET _argn ${_index} library)
      list(APPEND ${VAR} "${lib}${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}${library}")
    else()
      list(APPEND ${VAR} "${lib}")
    endif()
    math(EXPR _index "${_index} + 1")
  endwhile()
endmacro()

# unpack a list of libraries with optional build configuration keyword prefixes
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_unpack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  foreach(lib ${ARGN})
    string(REGEX REPLACE "^(debug|optimized|general)${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}(.+)$" "\\1;\\2" lib "${lib}")
    list(APPEND ${VAR} "${lib}")
  endforeach()
endmacro()


if(dccomms_ros_CONFIG_INCLUDED)
  return()
endif()
set(dccomms_ros_CONFIG_INCLUDED TRUE)

# set variables for source/devel/install prefixes
if("FALSE" STREQUAL "TRUE")
  set(dccomms_ros_SOURCE_PREFIX /tmp/binarydeb/ros-melodic-dccomms-ros-0.0.3)
  set(dccomms_ros_DEVEL_PREFIX /tmp/binarydeb/ros-melodic-dccomms-ros-0.0.3/obj-arm-linux-gnueabihf/devel)
  set(dccomms_ros_INSTALL_PREFIX "")
  set(dccomms_ros_PREFIX ${dccomms_ros_DEVEL_PREFIX})
else()
  set(dccomms_ros_SOURCE_PREFIX "")
  set(dccomms_ros_DEVEL_PREFIX "")
  set(dccomms_ros_INSTALL_PREFIX /opt/ros/melodic)
  set(dccomms_ros_PREFIX ${dccomms_ros_INSTALL_PREFIX})
endif()

# warn when using a deprecated package
if(NOT "" STREQUAL "")
  set(_msg "WARNING: package 'dccomms_ros' is deprecated")
  # append custom deprecation text if available
  if(NOT "" STREQUAL "TRUE")
    set(_msg "${_msg} ()")
  endif()
  message("${_msg}")
endif()

# flag project as catkin-based to distinguish if a find_package()-ed project is a catkin project
set(dccomms_ros_FOUND_CATKIN_PROJECT TRUE)

if(NOT "include " STREQUAL " ")
  set(dccomms_ros_INCLUDE_DIRS "")
  set(_include_dirs "include")
  if(NOT " " STREQUAL " ")
    set(_report "Check the issue tracker '' and consider creating a ticket if the problem has not been reported yet.")
  elseif(NOT " " STREQUAL " ")
    set(_report "Check the website '' for information and consider reporting the problem.")
  else()
    set(_report "Report the problem to the maintainer 'Diego Centelles <centelld@uji.es>' and request to fix the problem.")
  endif()
  foreach(idir ${_include_dirs})
    if(IS_ABSOLUTE ${idir} AND IS_DIRECTORY ${idir})
      set(include ${idir})
    elseif("${idir} " STREQUAL "include ")
      get_filename_component(include "${dccomms_ros_DIR}/../../../include" ABSOLUTE)
      if(NOT IS_DIRECTORY ${include})
        message(FATAL_ERROR "Project 'dccomms_ros' specifies '${idir}' as an include dir, which is not found.  It does not exist in '${include}'.  ${_report}")
      endif()
    else()
      message(FATAL_ERROR "Project 'dccomms_ros' specifies '${idir}' as an include dir, which is not found.  It does neither exist as an absolute directory nor in '\${prefix}/${idir}'.  ${_report}")
    endif()
    _list_append_unique(dccomms_ros_INCLUDE_DIRS ${include})
  endforeach()
endif()

set(libraries "dccomms_ros;ns3-dev-antenna-debug;ns3-dev-flow-monitor-test-debug;ns3-dev-propagation-debug;ns3-dev-antenna-test-debug;ns3-dev-internet-apps-debug;ns3-dev-propagation-test-debug;ns3-dev-aodv-debug;ns3-dev-internet-apps-test-debug;ns3-dev-sixlowpan-debug;ns3-dev-aodv-test-debug;ns3-dev-internet-debug;ns3-dev-sixlowpan-test-debug;ns3-dev-applications-debug;ns3-dev-internet-test-debug;ns3-dev-spectrum-debug;ns3-dev-applications-test-debug;ns3-dev-lr-wpan-debug;ns3-dev-spectrum-test-debug;ns3-dev-aqua-sim-ng-debug;ns3-dev-lr-wpan-test-debug;ns3-dev-stats-debug;ns3-dev-aqua-sim-ng-test-debug;ns3-dev-lte-debug;ns3-dev-stats-test-debug;ns3-dev-bridge-debug;ns3-dev-lte-test-debug;ns3-dev-tap-bridge-debug;ns3-dev-buildings-debug;ns3-dev-mesh-debug;ns3-dev-test-debug;ns3-dev-buildings-test-debug;ns3-dev-mesh-test-debug;ns3-dev-test-test-debug;ns3-dev-config-store-debug;ns3-dev-mobility-debug;ns3-dev-topology-read-debug;ns3-dev-core-debug;ns3-dev-mobility-test-debug;ns3-dev-topology-read-test-debug;ns3-dev-core-test-debug;ns3-dev-mpi-debug;ns3-dev-traffic-control-debug;ns3-dev-csma-debug;ns3-dev-netanim-debug;ns3-dev-traffic-control-test-debug;ns3-dev-csma-layout-debug;ns3-dev-netanim-test-debug;ns3-dev-uan-debug;ns3-dev-dsdv-debug;ns3-dev-network-debug;ns3-dev-uan-test-debug;ns3-dev-dsdv-test-debug;ns3-dev-network-test-debug;ns3-dev-virtual-net-device-debug;ns3-dev-dsr-debug;ns3-dev-nix-vector-routing-debug;ns3-dev-wave-debug;ns3-dev-dsr-test-debug;ns3-dev-olsr-debug;ns3-dev-wave-test-debug;ns3-dev-energy-debug;ns3-dev-olsr-test-debug;ns3-dev-wifi-debug;ns3-dev-energy-test-debug;ns3-dev-point-to-point-debug;ns3-dev-wifi-test-debug;ns3-dev-fd-net-device-debug;ns3-dev-point-to-point-layout-debug;ns3-dev-wimax-debug;ns3-dev-flow-monitor-debug;ns3-dev-point-to-point-test-debug;ns3-dev-wimax-test-debug;dccomms_utils;dccomms_packets;dccomms;cpputils;cpplogging;dccomms_class_loader")
foreach(library ${libraries})
  # keep build configuration keywords, target names and absolute libraries as-is
  if("${library}" MATCHES "^(debug|optimized|general)$")
    list(APPEND dccomms_ros_LIBRARIES ${library})
  elseif(${library} MATCHES "^-l")
    list(APPEND dccomms_ros_LIBRARIES ${library})
  elseif(${library} MATCHES "^-")
    # This is a linker flag/option (like -pthread)
    # There's no standard variable for these, so create an interface library to hold it
    if(NOT dccomms_ros_NUM_DUMMY_TARGETS)
      set(dccomms_ros_NUM_DUMMY_TARGETS 0)
    endif()
    # Make sure the target name is unique
    set(interface_target_name "catkin::dccomms_ros::wrapped-linker-option${dccomms_ros_NUM_DUMMY_TARGETS}")
    while(TARGET "${interface_target_name}")
      math(EXPR dccomms_ros_NUM_DUMMY_TARGETS "${dccomms_ros_NUM_DUMMY_TARGETS}+1")
      set(interface_target_name "catkin::dccomms_ros::wrapped-linker-option${dccomms_ros_NUM_DUMMY_TARGETS}")
    endwhile()
    add_library("${interface_target_name}" INTERFACE IMPORTED)
    if("${CMAKE_VERSION}" VERSION_LESS "3.13.0")
      set_property(
        TARGET
        "${interface_target_name}"
        APPEND PROPERTY
        INTERFACE_LINK_LIBRARIES "${library}")
    else()
      target_link_options("${interface_target_name}" INTERFACE "${library}")
    endif()
    list(APPEND dccomms_ros_LIBRARIES "${interface_target_name}")
  elseif(TARGET ${library})
    list(APPEND dccomms_ros_LIBRARIES ${library})
  elseif(IS_ABSOLUTE ${library})
    list(APPEND dccomms_ros_LIBRARIES ${library})
  else()
    set(lib_path "")
    set(lib "${library}-NOTFOUND")
    # since the path where the library is found is returned we have to iterate over the paths manually
    foreach(path /opt/ros/melodic/lib;/opt/ros/melodic/lib)
      find_library(lib ${library}
        PATHS ${path}
        NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH)
      if(lib)
        set(lib_path ${path})
        break()
      endif()
    endforeach()
    if(lib)
      _list_append_unique(dccomms_ros_LIBRARY_DIRS ${lib_path})
      list(APPEND dccomms_ros_LIBRARIES ${lib})
    else()
      # as a fall back for non-catkin libraries try to search globally
      find_library(lib ${library})
      if(NOT lib)
        message(FATAL_ERROR "Project '${PROJECT_NAME}' tried to find library '${library}'.  The library is neither a target nor built/installed properly.  Did you compile project 'dccomms_ros'?  Did you find_package() it before the subdirectory containing its code is included?")
      endif()
      list(APPEND dccomms_ros_LIBRARIES ${lib})
    endif()
  endif()
endforeach()

set(dccomms_ros_EXPORTED_TARGETS "")
# create dummy targets for exported code generation targets to make life of users easier
foreach(t ${dccomms_ros_EXPORTED_TARGETS})
  if(NOT TARGET ${t})
    add_custom_target(${t})
  endif()
endforeach()

set(depends "roscpp;rospy;std_msgs;actionlib_msgs;message_runtime;dccomms_ros_msgs")
foreach(depend ${depends})
  string(REPLACE " " ";" depend_list ${depend})
  # the package name of the dependency must be kept in a unique variable so that it is not overwritten in recursive calls
  list(GET depend_list 0 dccomms_ros_dep)
  list(LENGTH depend_list count)
  if(${count} EQUAL 1)
    # simple dependencies must only be find_package()-ed once
    if(NOT ${dccomms_ros_dep}_FOUND)
      find_package(${dccomms_ros_dep} REQUIRED NO_MODULE)
    endif()
  else()
    # dependencies with components must be find_package()-ed again
    list(REMOVE_AT depend_list 0)
    find_package(${dccomms_ros_dep} REQUIRED NO_MODULE ${depend_list})
  endif()
  _list_append_unique(dccomms_ros_INCLUDE_DIRS ${${dccomms_ros_dep}_INCLUDE_DIRS})

  # merge build configuration keywords with library names to correctly deduplicate
  _pack_libraries_with_build_configuration(dccomms_ros_LIBRARIES ${dccomms_ros_LIBRARIES})
  _pack_libraries_with_build_configuration(_libraries ${${dccomms_ros_dep}_LIBRARIES})
  _list_append_deduplicate(dccomms_ros_LIBRARIES ${_libraries})
  # undo build configuration keyword merging after deduplication
  _unpack_libraries_with_build_configuration(dccomms_ros_LIBRARIES ${dccomms_ros_LIBRARIES})

  _list_append_unique(dccomms_ros_LIBRARY_DIRS ${${dccomms_ros_dep}_LIBRARY_DIRS})
  list(APPEND dccomms_ros_EXPORTED_TARGETS ${${dccomms_ros_dep}_EXPORTED_TARGETS})
endforeach()

set(pkg_cfg_extras "")
foreach(extra ${pkg_cfg_extras})
  if(NOT IS_ABSOLUTE ${extra})
    set(extra ${dccomms_ros_DIR}/${extra})
  endif()
  include(${extra})
endforeach()
